/*
 * Condition.java
 *
 * Creation date unknown
 *
 */
package conversion;

/**
 *  A Condition is a strategy for deciding if data items satisfy a condition.
 *  A Condition can be used for selecting items in a
 *  @link sequential.SelectedSource} or a {@link sequential.SelectedSink}, or
 *  for terminating a {@link sequential.TerminatedSource}.
 */
public interface Condition<T> {

  /**
   *  c.isSatisfiedBy(o) returns true if c is satisfied by o, false if not.
   * @param o 
   * @return 
   */
  public boolean isSatisfiedBy(T o);

}  // public interface Condition

