/*
 * InverseConverter.java
 *
 * Created on August 17, 2006, 8:46 AM
 *
 */
package conversion;

import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

/**
 *  DOCME.
 *
 *  @author gshute
 */
public class InverseConverter<F, T>
        implements Converter<F, T> {

  private Map<F, T> map;

  /**
   *  DOCME.
   */
  private void checkedPut(F f, T t) {
    if (map.containsKey(f)) {
      throw new IllegalArgumentException("Duplicate keys");
    }
    map.put(f, t);
  }

  /**
   *  This constructor is disabled.
   */
  private InverseConverter() {
    map = new HashMap<F, T>();
  }

  /**
   *  new InverseConverter(c, itbl) returns a new InverseConverter.
   * @param c 
   * @param itbl 
   */
  public InverseConverter(Converter<T, F> c, Iterable<T> itbl) {
    super();
    setConversion(c, itbl);
  }

  /**
   *  new InverseConverter(c, iter) returns a new InverseConverter.
   * @param c 
   * @param iter 
   */
  public InverseConverter(Converter<T, F> c, Iterator<T> iter) {
    super();
    setConversion(c, iter);
  }

  /**
   *  new InverseConverter(c, ta) returns a new InverseConverter.
   * @param c 
   * @param ta 
   */
  public InverseConverter(Converter<T, F> c, T[] ta) {
    super();
    setConversion(c, ta);
  }

  /**
   * 
   * @param c 
   * @param itbl 
   */
  public void setConversion(Converter<T, F> c, Iterable<T> itbl) {
    map.clear();
    for (T t : itbl) {
      checkedPut(c.convertTo(t), t);
    }
  }

  /**
   *  DOCME.
   * @param c 
   * @param iter 
   */
  public void setConversion(Converter<T, F> c, Iterator<T> iter) {
    map.clear();
    while (iter.hasNext()) {
      T t = iter.next();
      checkedPut(c.convertTo(t), t);
    }
  }

  /**
   *  DOCME.
   * @param c 
   * @param ta 
   */
  public void setConversion(Converter<T, F> c, T[] ta) {
    map.clear();
    for (T t : ta) {
      checkedPut(c.convertTo(t), t);
    }
  }

  /**
   *  DOCME.
   * @param f 
   * @return 
   */
  public T convertTo(F f) {
    return map.get(f);
  }

}  // public class InverseConverter
