/*
 * Scaler.java
 *
 * Created on July 24, 2006, 9:32 AM
 *
 */
package conversion;

/**
 *  A Scaler converts double values to scaled double values.
 *
 *  @author gshute
 */
public interface Scaler {

  /**
   *  sc.scale(val) returns sc's scaled value for val.
   * @param val 
   * @return 
   */
  public double scale(double val);

  /**
   *  sc.getReverseScaler() returns a scaler that performs
   *  scaling that is inverse to sc's scaling.
   *  The returned scaler tracks changes in parameters that
   *  control sc's scaling.
   * @return 
   */
  public Scaler getReverseScaler();

}  // public interface Scaler
