package file;

import java.io.File;
import java.io.IOException;
import static javax.swing.JOptionPane.*;
import javax.swing.JOptionPane;

/**
 *  FIXME - add comment.
 *  FIXME - add methods for verify dialogs such as overriding
 *  permissions or overwriting existing files.
 */
public class FileDialogs
        extends Object {

  /**
   *
   */
  private static String[] formattedMessage = new String[]{
    null,
    "",
    null
  };

  /**
   *  This constructor is disabled.
   *  All methods in this class are static.
   */
  private FileDialogs() {
  }

  /**
   *
   */
  private static String getFileName(IOException ex) {
    String message = ex.getMessage();
    int nameEnd = message.indexOf('(');
    if (nameEnd < 0) {
      nameEnd = message.length();
    } else {
      nameEnd--;
    }
    return message.substring(0, nameEnd);
  }

  /**
   *
   */
  private static String getMessage(IOException ex) {
    String message = ex.getMessage();
    int messageStart = message.indexOf('(');
    int messageEnd = message.length() - 1;
    if (messageStart < 0) {
      messageStart = 0;
      messageEnd = 0;
    } else {
      messageStart++;
    }
    return message.substring(messageStart, messageEnd);
  }

  /**
   * 
   * @param typ 
   * @param ex 
   */
  public static void showError(String typ, IOException ex) {
    showError(typ, getFileName(ex), getMessage(ex));
  }

  /**
   * 
   * @param typ 
   * @param f 
   * @param msg 
   */
  public static void showError(String typ, File f, String msg) {
    showError(typ, f.getName(), msg);
  }

  /**
   * 
   * @param typ 
   * @param fnm 
   * @param msg 
   */
  public static void showError(String typ, String fnm, String msg) {
    formattedMessage[0] = fnm;
    formattedMessage[1] = "";
    formattedMessage[2] = msg;
    JOptionPane.showMessageDialog(null, formattedMessage,
            typ + " Error", ERROR_MESSAGE);
  }

  /**
   * 
   * @param f 
   * @return 
   */
  public static int verifyOverwrite(File f) {
    return verifyOverwrite(f.getName());
  }

  /**
   * 
   * @param fnm 
   * @return 
   */
  public static int verifyOverwrite(String fnm) {
    formattedMessage[0] = "Do you want to overwrite the file";
    formattedMessage[1] = "";
    formattedMessage[2] = fnm + "?";
    return JOptionPane.showConfirmDialog(null, formattedMessage,
            "Confirm Overwrite", YES_NO_CANCEL_OPTION);
  }

  /**
   * 
   * @param typ 
   * @param f 
   * @return 
   */
  public static int verifyOverride(String typ, File f) {
    return verifyOverride(typ, f.getName());
  }

  /**
   * 
   * @param typ 
   * @param fnm 
   * @return 
   */
  public static int verifyOverride(String typ, String fnm) {
    formattedMessage[0] = fnm;
    formattedMessage[1] = "";
    formattedMessage[2] = "Do you want to override permissions?";
    return JOptionPane.showConfirmDialog(null, formattedMessage,
            "Confirm Override", YES_NO_CANCEL_OPTION);
  }

}  // public class FileDialogs
