package file;

import java.io.File;
import java.io.IOException;

/**
 *  A FileFormatException is an IOException arising from
 *  an invalid file format.
 */
public class FileFormatException
        extends IOException {

  private String fileName;

  /**
   *  This constructor is disabled.
   *  A FileFormatException requires a file or
   *  a file name.
   */
  private FileFormatException() {
  }

  /**
   *  new FileFormatException(f) returns a new
   *  FileFormatException for the file f.
   * @param f 
   */
  public FileFormatException(File f) {
    this(f.getName());
  }

  /**
   *  new FileFormatException(fnm) returns a new
   *  FileFormatException for the file named fnm.
   * @param fnm 
   */
  public FileFormatException(String fnm) {
    fileName = fnm;
  }

  /**
   *  ffe.getMessage() returns a string specifying
   *  the name of the file and the nature of the error.
   * @return 
   */
  public String getMessage() {
    return fileName + "(Invalid file format)";
  }

}  // public class FileFormatException

