package file;

import gui.GriddedPanel;
import java.io.File;
import javax.swing.JComponent;

/**
 *  @author AUTHOR
 */
public class FilePanel
        extends GriddedPanel {

  private FileGroup fileGroup;

  private void addFiles() {
    removeAll();
    for (int i = 0; i < fileGroup.getFileCount(); i++) {
      File file = fileGroup.getFile(i);
      JComponent component = new FileVisual(file).getVisual();
      add(component);
    }
  }

  public FilePanel(FileType ft) {
    this(new FileGroup(ft));
  }

  public FilePanel(FileGroup fg) {
    fileGroup = fg;
    addFiles();
  }

  public void setCurrentDirectory(File dir) {
    fileGroup.setDirectory(dir);
    addFiles();
  }

}

