package file;

import java.io.File;
import javax.swing.JComponent;
import javax.swing.JLabel;

/**
 *  @author AUTHOR
 */
public class FileVisual
        extends Object {

  private File file;
  private FileType fileType;
  private JLabel visual;

  /**
   *  This constructor is disabled.
   *  A FileVisual must have a file type and a file or file name.
   */
  private FileVisual() {
  }

  /**
   *  new FileVisual(fnm, dir) returns a new FileVisual for the file 
   *  named fnm in the direcory dir.
   */
  public FileVisual(String fnm, File dir) {
    this(new File(dir, fnm));
  }

  /**
   *  new FileVisual(fnm) returns a new FileVisual for the file f.
   */
  public FileVisual(File f) {
    file = f;
    fileType = FileType.getType(file);
    visual = new JLabel(file.getName(), fileType.getIcon(), JLabel.CENTER);
    visual.setHorizontalTextPosition(JLabel.CENTER);
    visual.setVerticalTextPosition(JLabel.BOTTOM);
  }

  public JComponent getVisual() {
    return visual;
  }

}  // public class FileVisual

