package file;

import java.net.URL;
import java.util.HashMap;
import java.util.Map;
import javax.swing.Icon;
import javax.swing.ImageIcon;

public class IconManager {

  private static Map<String, Icon> icons =
          new HashMap<String, Icon>();

  public static Icon getIcon(String nm) {
    if (icons.containsKey(nm)) {
      return (Icon) icons.get(nm);
    }
    URL iconURL = IconManager.class.getResource("icons/" + nm);
    Icon icon = new ImageIcon(iconURL);
    if (icon != null) {
      icons.put(nm, icon);
    }
    return icon;
  }

}

