package file;

import java.io.File;
import java.io.IOException;
import mvc.NamedModel;

/**
 *  A Storable is a model that can be read from and written to
 *  a file.
 */
public interface Storable<T>
        extends NamedModel<T> {

  /**
   *  st.clear() sets st to an initial state with empty
   *  content.
   */
  public void clear();

  /**
   *  st.read(f) reads into st from the file f.
   * @param f 
   * @throws java.io.IOException 
   */
  public void read(File f)
          throws IOException;

  /**
   *  st.write(f) writes from st to the file f.
   * @param f 
   * @throws java.io.IOException 
   */
  public void write(File f)
          throws IOException;

}  // public interface Storable
