package file;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import javax.swing.JFileChooser;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.filechooser.FileFilter;

/**
 *  FIXME - add comment.
 *  FIXME - Create a list of file actions rather than a menu.
 *  FIXME - Support multiple fileables.
 *  FIXME - Implement MultipleChoice interface.
 *  FIXME - Support tracking modified status.
 *  FIXME - Support tracking file modification and last read times.
 *  Use this to check for external modifications of files.
 *  FIXME - Add "Save All" action.
 *  FIXME - Add file type management.
 *  Need to think this through.
 *  Perhaps we need two classes: WorkSpaceItem and WorkSpace?
 */
public class WorkSpace
        extends Object {

  private File targetFile;
  private JFileChooser fileChooser;
  private JMenu menu;
  private Storable fileable;

  /**
   *
   */
  private void doOpen(File f) {
    try {
      fileable.read(f);
      targetFile = f;
    } catch (IOException ex) {
      FileDialogs.showError("Open", ex);
    }
  }

  /**
   *
   */
  private void doSave(File f) {
    if (f == null) {
      return;
    }
    try {
      fileable.write(f);
      targetFile = f;
    } catch (IOException ex) {
      FileDialogs.showError("Save", ex);
    }
  }

  /**
   *
   */
  private File getSaveFile() {
    int returnVal = fileChooser.showSaveDialog(null);
    if (returnVal != JFileChooser.APPROVE_OPTION) {
      return null;
    }
    File file = fileChooser.getSelectedFile();
    if (file != null && file.exists()) {
      int choice = FileDialogs.verifyOverwrite(file);
      if (choice != JOptionPane.OK_OPTION) {
        return null;
      }
    }
    return file;
  }

  /**
   *
   */
  private JMenuItem createNewMenuItem() {
    JMenuItem menuItem = new JMenuItem("New");
    ActionListener actionListener = new ActionListener() {

      public void actionPerformed(ActionEvent ev) {
        targetFile = null;
        fileable.clear();
      }

    };
    menuItem.addActionListener(actionListener);
    return menuItem;
  }

  /**
   *
   */
  private JMenuItem createOpenMenuItem() {
    JMenuItem menuItem = new JMenuItem("Open...");
    ActionListener actionListener = new ActionListener() {

      public void actionPerformed(ActionEvent ev) {
        int returnVal = fileChooser.showOpenDialog(null);
        if (returnVal == JFileChooser.APPROVE_OPTION) {
          doOpen(fileChooser.getSelectedFile());
        }
      }

    };
    menuItem.addActionListener(actionListener);
    return menuItem;
  }

  /**
   *
   */
  private JMenuItem createSaveMenuItem() {
    JMenuItem menuItem = new JMenuItem("Save");
    ActionListener actionListener = new ActionListener() {

      public void actionPerformed(ActionEvent ev) {
        if (targetFile == null) {
          doSave(getSaveFile());
        } else {
          doSave(targetFile);
        }
      }

    };
    menuItem.addActionListener(actionListener);
    return menuItem;
  }

  /**
   *
   */
  private JMenuItem createSaveAsMenuItem() {
    JMenuItem menuItem = new JMenuItem("Save As...");
    ActionListener actionListener = new ActionListener() {

      public void actionPerformed(ActionEvent ev) {
        doSave(getSaveFile());
      }

    };
    menuItem.addActionListener(actionListener);
    return menuItem;
  }

  /**
   *
   */
  public WorkSpace() {
    targetFile = null;
    fileChooser = new JFileChooser(System.getProperty("user.dir"));
    menu = new JMenu("File");
    menu.add(createNewMenuItem());
    menu.add(createOpenMenuItem());
    menu.add(createSaveMenuItem());
    menu.add(createSaveAsMenuItem());
  }

  /**
   *  ws.getFileMenu() returns a file menu for ws with "New", "Open...",
   *  "Save", and "Save As..." menu items.
   * @return 
   */
  public JMenu getFileMenu() {
    return menu;
  }

  /**
   *  ws.setFileable(flbl) sets the fileable of ws to flbl.
   * @param flbl 
   */
  public void setFileable(Storable flbl) {
    fileable = flbl;
  }

  /**
   *  ws.setFilter(fltr) sets the file filter of ws to fltr.
   * @param fltr 
   */
  public void setFilter(FileFilter fltr) {
    fileChooser.setFileFilter(fltr);
  }

}  // public class WorkSpace

