package gui;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import javax.swing.JOptionPane;
import sun.print.PSPrinterJob;

/**
 *
 * @author gshute
 */
public class EPSImageType
        extends ImageType {

  private Printable createPrintable(final Component c) {
    return new Printable() {

      public int print(Graphics g, PageFormat fmt, int pageNum) {
        if (pageNum > 0) {
          return Printable.NO_SUCH_PAGE;
        }
        c.print(g);
        return Printable.PAGE_EXISTS;
      }

    };
  }

  public EPSImageType() {
    super("eps");
  }

  public boolean isAvailable() {
    return true;
  }

  public void write(File f, Component c)
          throws IOException {
    PrintStream outputStream = new PrintStream(f);
    try {
      Printable printable = createPrintable(c);
      PSPrinterJob.EPSPrinter printer = new PSPrinterJob.EPSPrinter(printable,
              "", outputStream, 0, 0, c.getWidth(), c.getHeight());
      printer.print();
      outputStream.close();
    } catch (PrinterException ex) {
      JOptionPane.showMessageDialog(c, ex.getMessage(),
              "Export Error", JOptionPane.ERROR_MESSAGE);
    }
  }

}
