/*
 * CallbackExecutor.java
 *
 * Created on August 6, 2006, 4:24 PM
 *
 */
package mvc;

import java.util.ArrayList;
import java.util.List;

/**
 *  A CallbackExecutor provides a registration, unregistration and
 *  execution service for callbacks.
 * 
 *  @author gshute
 */
public class CallbackExecutor
        implements CallbackRegistry {

//  private Map<Callback, Integer> counts;
  private List<Callback> callbackList;

  /**
   *  new CallbackExecutor() returns a new CallbackExecutor.
   */
  public CallbackExecutor() {
//    counts = new HashMap<Callback, Integer>();
    callbackList = new ArrayList<Callback>(); 
  }

  /**
   *  ce.executeCallbacks() sends an execute() message to
   *  all callbacks that are registered with ce.
   */
  protected void executeCallbacks() {
//    for (Callback callback : counts.keySet()) {
    for (Callback callback : callbackList) {
      callback.execute();
    }
  }

  /**
   *  ce.addCallback(cbk) registers cbk as an callback that is
   *  executed by ce when ce.executeCallbacks() is invoked.
   * @param cbk the callback to be registered
   */
  public void addCallback(Callback cbk) {
//    Integer count = counts.get(cbk);
//    if (count == null) {
//      count = 0;
//    }
//    counts.put(cbk, count + 1);
    callbackList.add(cbk);
  }

  /**
   *  ce.removeCallback(cbk) unregisters cbk as an callback
   *  that is executed by ce when ce.executeCallbacks() is
   *  invoked.
   * @param cbk the callback to be unregistered
   */
  public void removeCallback(Callback cbk) {
//    Integer count = counts.get(cbk);
//    if (count == null) {
//      return;
//    }
//    count--;
//    if (count == 0) {
//      counts.remove(cbk);
//    } else {
//      counts.put(cbk, count);
//    }
    callbackList.remove(cbk);
  }

}  // public class CallbackExecutor
