/*
 * CallbackRegistry.java
 *
 * Created on August 11, 2006, 10:10 AM
 *
 */
package mvc;

/**
 *  A CallbackRegistry provides registration and unregistration
 *  service for callbacks.
 * 
 *  @author gshute
 */
public interface CallbackRegistry {

  /**
   *  cr.addCallback(cbk) registers cbk as a callback of cr.
   * @param cbk the callback to be registered
   */
  public void addCallback(Callback cbk);

  /**
   *  cr.removeCallback(cbk) unregisters cbk as a callback of cr.
   * @param cbk the callback to be unregistered
   */
  public void removeCallback(Callback cbk);

}  // public interface CallbackRegistry
