/*
 * CardView.java
 *
 * Created on July 26, 2006, 1:31 PM
 *
 */
package mvc;

import gui.Viewable;
import gui.WrapMethod;
import gui.Wrapper;
import java.awt.CardLayout;
import java.util.HashMap;
import javax.swing.JComponent;
import javax.swing.JPanel;

/**
 *  DOCME.
 *
 *  @author gshute
 */
public class CardView<T extends Viewable>
        implements View<T, Choice.Model<? extends T>> {

  private Choice.Model<? extends T> model;
  private CardLayout layout;
  private JPanel panel;
  private Callback callback;
  private HashMap<Object, String> names;
  private WrapMethod wrapMethod;

  /**
   *  DOCME.
   */
  private void setView() {
    layout.show(panel, names.get(model.getValue()));
  }

  /**
   *  DOCME.
   */
  private void setChoice(Choice<? extends Viewable> c) {
    names.clear();
    panel.removeAll();
    int index = 0;
    for (Viewable viewable : c) {
      String name = "" + index;
      names.put(viewable, name);
      panel.add(wrapMethod.getWrapComponent(viewable), name);
      index++;
    }
  }

  /**
   *  This constructor is disabled.
   *  A CardView must have a model.
   */
  private CardView() {
  }

  /**
   *  new CardView(m) returns a new CardView.
   * @param m 
   */
  public CardView(Choice.Model<? extends T> m) {
    this(m, Wrapper.createUnwrappedWrapMethod());
  }

  /**
   *  new CardView(m) returns a new CardView.
   * @param m 
   */
  public CardView(Choice.Model<? extends T> m, WrapMethod wm) {
    model = m;
    wrapMethod = wm;
    layout = new CardLayout();
    panel = new JPanel(layout);
    callback = new Callback() {

      public void execute() {
        setView();
      }

    };
    names = new HashMap<Object, String>();
    setModel(m);
  }

  /**
   *  DOCME.
   * @return 
   */
  public JComponent getViewComponent() {
    return panel;
  }

  /**
   *  DOCME.
   * @param m 
   */
  public void setModel(Choice.Model<? extends T> m) {
    if (model != null) {
      model.removeCallback(callback);
    }
    panel.removeAll();
    model = m;
    setChoice(model.getChoice());
    model.addCallback(callback);
    setView();
  }

}  // public class CardView
