/*
 * ComboBoxChooser.java
 *
 * Created on August 18, 2006, 9:59 AM
 *
 */
package mvc;

import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Iterator;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JPanel;
import conversion.Converter;
import conversion.Namer;
import conversion.NamerConverter;
import conversion.ToStringConverter;

/**
 *  DOCME.
 *
 *  @author gshute
 */
public class ComboBoxChooser<T>
        extends Choice.ControllerImplementation<T, String> {

  private JComboBox comboBox;

  /**
   *  DOCME.
   * @return 
   */
  protected JComponent createViewComponent() {
    comboBox = new JComboBox();
    comboBox.addActionListener(new ActionListener() {

      public void actionPerformed(ActionEvent ev) {
        setModelValue();
      }

    });
    return comboBox;
  }

  /**
   *  DOCME.
   * @param nms 
   */
  protected void setDisplayObjects(Iterator<String> nms) {
    comboBox.removeAllItems();
    while (nms.hasNext()) {
      comboBox.addItem(nms.next());
    }
  }

  /**
   *  DOCME.
   * @param nm 
   */
  protected void setViewIndex(int nm) {
    comboBox.setSelectedIndex(nm);
  }

  /**
   *  DOCME.
   * @return 
   */
  protected int getViewIndex() {
    return comboBox.getSelectedIndex();
  }

  /**
   *  new ComboBoxChooser(m) returns a new ComboBoxChooser.
   * @param m 
   */
  public ComboBoxChooser(Choice.Model<? extends T> m) {
    super(m, new ToStringConverter());
  }

  /**
   *  new ComboBoxChooser(m, cvtr) returns a new ComboBoxChooser.
   * @param m 
   * @param cvtr 
   */
  public ComboBoxChooser(Choice.Model<? extends T> m,
          Converter<? super T, ? extends String> cvtr) {
    super(m, cvtr);
  }

  /**
   *  new ComboBoxChooser(m, cvtr) returns a new ComboBoxChooser.
   * @param m 
   * @param nmr 
   */
  public ComboBoxChooser(Choice.Model<? extends T> m,
          Namer<? super T> nmr) {
    super(m, new NamerConverter<T>(nmr));
  }

}  // public class ComboBoxChooser<T, MT>
