/*
 * NamedDirectModel.java
 *
 * Created on August 1, 2006, 10:33 PM
 *
 */
package mvc;

/**
 *  DOCME.
 *
 *  @author gshute
 */
public abstract class DirectModel<T>
        implements Model<T> {

  CallbackExecutor notifier;

  /**
   *  executeCallbacks() invokes the execute() method for all
   *  callbacks of this model.
   */
  protected void notifyObservers() {
    notifier.executeCallbacks();
  }

  /**
   *  new NamedDirectModel<T>() returns a new NamedDirectModel<T>.
   */
  public DirectModel() {
    notifier = new CallbackExecutor();
  }

  /**
   *  m.addCallback(cbk) registers cbk as an callback of m.
   * @param cbk 
   */
  public void addCallback(Callback cbk) {
    notifier.addCallback(cbk);
  }

  /**
   *  m.removeCallback(cbk) unregisters cbk as an callback of m.
   * @param cbk 
   */
  public void removeCallback(Callback cbk) {
    notifier.removeCallback(cbk);
  }

}  // public class NamedDirectModel
