package mvc;

import java.io.IOException;
import java.net.URL;
import javax.swing.JComponent;
import javax.swing.JEditorPane;

/**
 *  DOCME.
 *
 *  @author gshute
 */
public class HTMLView
        implements View<URL, Model<? extends URL>> {

  private JEditorPane editorPane;
  private Callback callback;
  private Model<? extends URL> model;

  private void setPage(URL url) {
    try {
      editorPane.setPage(url);
    } catch (IOException ex) {
      try {
        editorPane.setPage(getClass().getResource("urlError.html"));
      } catch (IOException ex1) {
        // This should never happen.
        System.err.println(ex1);
      }
    }
  }

  /**
   *  DOCME.
   * @param m 
   */
  public HTMLView(NamedModel<? extends URL> m) {
    editorPane = new JEditorPane("text/html", null);
    editorPane.setEditable(false);
    editorPane.putClientProperty(
            JEditorPane.HONOR_DISPLAY_PROPERTIES, Boolean.TRUE);
    callback = new Callback() {

      public void execute() {
        setPage(model.getValue());
      }

    };
    setModel(m);
  }

  /**
   *  DOCME.
   * @return 
   */
  public JComponent getViewComponent() {
    return editorPane;
  }

  /**
   *  DOCME.
   * @param m 
   */
  public void setModel(Model<? extends URL> m) {
    if (model != null) {
      model.removeCallback(callback);
    }
    model = m;
    model.addCallback(callback);
    setPage(model.getValue());
  }

} // public class HTMLView
