/*
 * ListChooser.java
 *
 * Created on August 6, 2006, 4:24 PM
 *
 */
package mvc;

import java.util.Iterator;
import javax.swing.DefaultListModel;
import javax.swing.JComponent;
import javax.swing.JList;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import conversion.Converter;
import conversion.Namer;
import conversion.NamerConverter;
import conversion.ToStringConverter;

/**
 *  DOCME.
 *
 *  @author gshute
 */
public class ListChooser<T>
        extends Choice.ControllerImplementation<T, String> {

  private DefaultListModel model;
  private JList list;

  /**
   *  DOCME.
   * @return 
   */
  protected JComponent createViewComponent() {
    model = new DefaultListModel();
    list = new JList(model);
    list.addListSelectionListener(new ListSelectionListener() {

      public void valueChanged(ListSelectionEvent ev) {
        setModelValue();
      }

    });
    return list;
  }

  /**
   *  DOCME.
   * @param nms 
   */
  protected void setDisplayObjects(Iterator<String> nms) {
    model.clear();
    while (nms.hasNext()) {
      model.addElement(nms.next());
    }

  }

  /**
   *  DOCME.
   * @param nm 
   */
  protected void setViewIndex(int nm) {
    list.setSelectedIndex(nm);
  }

  /**
   *  DOCME.
   * @return 
   */
  protected int getViewIndex() {
    return list.getSelectedIndex();
  }

  /**
   *  new ListChooser(m) returns a new ListChooser.
   * @param m 
   */
  public ListChooser(Choice.Model<? extends T> m) {
    super(m, new ToStringConverter());
  }

  /**
   *  new ListChooser(m, cvtr) returns a new ListChooser.
   * @param m 
   * @param cvtr 
   */
  public ListChooser(Choice.Model<? extends T> m,
          Converter<? super T, ? extends String> cvtr) {
    super(m, cvtr);
  }

  /**
   *  new ListChooser(m, cvtr) returns a new ListChooser.
   * @param m 
   * @param nmr 
   */
  public ListChooser(Choice.Model<? extends T> m,
          Namer<? super T> nmr) {
    super(m, new NamerConverter<T>(nmr));
  }

}  // public class ListChooser<T, MT>
