/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package mvc;

import conversion.NamedNamer;
import conversion.Namer;
import gui.Spacer;
import java.awt.BorderLayout;
import java.awt.Color;
import javax.swing.JComponent;
import javax.swing.JPanel;
import javax.swing.SwingUtilities;

/**
 *
 * @author gshute
 */
public class NonLeafCascadedChooser<T>
        extends CompositeModel<T, CascadedChooser<T>>
        implements CascadedChooser<T> {

  private JPanel viewComponent;
  private JPanel mainPanel;
  private CascadedChooser<T> selectedSubmodel;
  private ListChooser<CascadedChooser<T>> submodelChooser;
  private Spacer spacer;

  private void replaceSelectedSubmodelView(CascadedChooser<T> sm) {
    if (sm == selectedSubmodel) {
      return;
    }
    JComponent submodelViewComponent = selectedSubmodel.getViewComponent();
    if (submodelViewComponent != null) {
      mainPanel.remove(submodelViewComponent);
    }
    JComponent newSubmodelViewComponent = sm.getViewComponent();
    if (newSubmodelViewComponent != null) {
      SwingUtilities.updateComponentTreeUI(newSubmodelViewComponent);
      mainPanel.add(newSubmodelViewComponent, BorderLayout.CENTER);
    }
    selectedSubmodel = sm;
    viewComponent.validate();
    viewComponent.repaint();
  }

  public NonLeafCascadedChooser(String nm, Iterable<CascadedChooser<T>> sc) {
    super(nm, new Choice<CascadedChooser<T>>(sc));

    // Create the view component.
    viewComponent = new JPanel(new BorderLayout());
    viewComponent.setBackground(Color.WHITE);
    spacer = new Spacer(1.5f);
    viewComponent.add(spacer, BorderLayout.NORTH);
    mainPanel = new JPanel(new BorderLayout());
    viewComponent.add(mainPanel, BorderLayout.CENTER);
    Choice.Model<CascadedChooser<T>> submodelModel = getSubmodelModel();
    Namer<CascadedChooser<T>> namer = new NamedNamer<CascadedChooser<T>>();
    submodelChooser =
            new ListChooser<CascadedChooser<T>>(submodelModel, namer);
    mainPanel.add(submodelChooser.getViewComponent(), BorderLayout.NORTH);
    selectedSubmodel = getSelectedSubmodel();
    JComponent submodelViewComponent = selectedSubmodel.getViewComponent();
    if (submodelViewComponent != null) {
      mainPanel.add(submodelViewComponent, BorderLayout.CENTER);
    }

    // Add a callback to update the view component when the selected submodel
    // is changed.
    getSubmodelModel().addCallback(new Callback() {

      public void execute() {
        replaceSelectedSubmodelView(getSelectedSubmodel());
      }

    });

  }

  public JPanel getViewComponent() {
    return viewComponent;
  }

  public void setSpacerSizeEm(float wEm, float hEm) {
    spacer.setSizeEm(wEm, hEm);
    Choice<CascadedChooser<T>> choice = getSubmodelModel().getChoice();
    for (CascadedChooser chooser : choice) {
      chooser.setSpacerSizeEm(wEm, hEm);
    }
    viewComponent.invalidate();
  }

}
