/*
 * PainterView.java
 *
 * Created on August 13, 2006, 4:44 PM
 *
 */
package mvc;

import java.awt.Graphics;
import java.awt.Graphics2D;
import javax.swing.JComponent;
import javax.swing.JPanel;

/**
 *  DOCME.
 *
 *  @author gshute
 */
public class PainterView
        implements View<Painter, NamedModel<? extends Painter>> {

  /**
   *  new PaintPane() returns a new PaintPane.
   */
  private class PaintPane
          extends JPanel {

    /**
     *  DOCME.
     */
    private PaintPane() {
      super();
    }

    /**
     *  DOCME.
     * @param g
     */
    public void paintComponent(Graphics g) {
      Graphics2D g2d = (Graphics2D) g;
      model.getValue().paintOn(g2d);
    }

  }  // private class PaintPane

  private PaintPane paintPane;
  private Callback callback;
  private NamedModel<? extends Painter> model;

  /**
   *  DOCME.
   * @param m 
   */
  public PainterView(NamedModel<? extends Painter> m) {
    paintPane = new PaintPane();
    callback = new Callback() {

      public void execute() {
        paintPane.repaint();
      }

    };
    setModel(m);
  }

  /**
   *  DOCME.
   * @return 
   */
  public JComponent getViewComponent() {
    return paintPane;
  }

  /**
   *  DOCME.
   * @param m 
   */
  public void setModel(NamedModel<? extends Painter> m) {
    model = m;
    paintPane.repaint();
  }

}  // public class PainterView
