/*
 * TabbedChooser.java
 *
 * Created on August 6, 2006, 4:24 PM
 *
 */
package mvc;

import java.util.Iterator;
import javax.swing.JComponent;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import conversion.Converter;
import conversion.Namer;
import conversion.NamerConverter;
import conversion.ToStringConverter;

/**
 *  DOCME.
 *
 *  @author gshute
 */
public class TabbedChooser<T>
        extends Choice.ControllerImplementation<T, String> {

  private Tabber tabber;

  /**
   *  tc.createViewComponent() returns the component that
   * displays the choices of tc.
   * 
   * @return the view component
   */
  protected JComponent createViewComponent() {
    tabber = new Tabber();
    tabber.addChangeListener(new ChangeListener() {

      public void stateChanged(ChangeEvent ev) {
        setModelValue();
      }

    });
    return tabber;
  }

  /**
   *  tc.setDisplayObjects(nms) sets the displayed choices
   *  of tc to the names iterated by nms
   * .
   * @param nms the names to be displayed
   */
  protected void setDisplayObjects(Iterator<String> nms) {
    tabber.removeAll();
    while (nms.hasNext()) {
      tabber.add(nms.next());
    }
    tabber.setWidth();
  }

  /**
   *  tc.setViewIndex(i) sets the choice with view index i
   *  as the selected item of tc.
   * @param nm 
   */
  protected void setViewIndex(int nm) {
    tabber.setSelectedIndex(nm);
  }

  /**
   *  DOCME.
   * @return 
   */
  protected int getViewIndex() {
    return tabber.getSelectedIndex();
  }

  /**
   *  new TabbedChooser(m, w) returns a new TabbedChooser
   *  with width w.
   * @param m 
   */
  public TabbedChooser(Choice.Model<? extends T> m, int w) {
    super(m, new ToStringConverter());
    tabber.setWidth(w);
  }

  /**
   *  new TabbedChooser(m, cvtr, w) returns a new TabbedChooser
   *  with width w.
   * @param m 
   * @param cvtr 
   */
  public TabbedChooser(Choice.Model<? extends T> m,
          Converter<? super T, ? extends String> cvtr, int w) {
    super(m, cvtr);
    tabber.setWidth(w);
  }

  /**
   *  new TabbedChooser(m, cvtr, w) returns a new TabbedChooser
   *  with width w.
   * @param m 
   * @param nmr 
   */
  public TabbedChooser(Choice.Model<? extends T> m,
          Namer<? super T> nmr, int w) {
    super(m, new NamerConverter<T>(nmr));
    tabber.setWidth(w);
  }

}  // public class TabbedChooser<T, MT>
