package vfs;

/**
 * A VFSError is used to rethrow checked
 * exceptions as unchecked exceptions, which
 * do not require a try..catch statement.
 * It should mainly be used to rethrow
 * exceptions that are due to coding errors.
 */
public class VFSError extends Error {

  /**
   * throw new VFSError(ex) rethrows ex as an
   * unchecked execption with no additional
   * message.
   *  
   * @param ex
   */
  public VFSError(Throwable ex) {
    super(ex);
  }

  /**
   * throw new VFSError(msg, ex) rethrows ex
   * as an unchecked execption with additional
   * message msg.
   *  
   * @param ex
   */
  public VFSError(String msg, Throwable ex) {
    super(msg, ex);
  }
  
}  // public class VFSError
