package vfs;

import java.net.URL;

/**
 * A VFSItem is an item in a virtual file system.
 * It has a name and a URL.
 * <p>
 * This is the Component class in a Composite
 * design pattern whose other classes are
 * VFSFile (Leaf) and VFSDirectory (Composite).
 * </p>
 * 
 * @author gshute
 */
public interface VFSItem {

  /**
   * itm.getName() returns the name of itm.
   * 
   * @return the name of the item
   */
  public String getName();

  /**
   * itm.getURL() returns the URL for itm.
   * 
   * @return the URL for the item
   */
  public URL getURL();

}  // public class VFSItem
